diff --git a/main.asm b/main.asm
index 0d81c646..b3e2074b 100755
--- a/main.asm
+++ b/main.asm
@@ -67469,7 +67924,7 @@ Func_3fbbc: ; 3fbbc (f:7bbc)
 	pop de
 	pop hl
 	ret
-; 3fbc8 (f:7bc8)
+
 SECTION "bank10",ROMX,BANK[$10]
 
 DisplayPokedexMenu_: ; 40000 (10:4000)
@@ -69604,13 +70059,19 @@ PokedexOrder: ; 41024 (10:5024)
 Func_410e2: ; 410e2 (10:50e2)
 	ld a, [wWhichTrade] ; $cd3d
 	ld [$cd5e], a
-	ld a, [$cd3e]
+	ld a, [wTrainerEngageDistance]
 	ld [$cd5f], a
 	ld de, Unknown_41138 ; $5138
-	jr .asm_41102
+	jr Func_41102
 
-INCBIN "baserom.gbc",$410f3,$41102 - $410f3
-.asm_41102
+Func_410f3: ; 410f3 (10:50f3)
+	ld a, [wTrainerEngageDistance]
+	ld [$cd5e], a
+	ld a, [wTrainerSpriteOffset]
+	ld [$cd5f], a
+	ld de, Unknown_41149
+
+Func_41102: ; 41102 (10:5102)
 	ld a, [W_OPTIONS] ; $d355
 	push af
 	ld a, [$FF00+$af]
@@ -69650,7 +70111,10 @@ INCBIN "baserom.gbc",$410f3,$41102 - $410f3
 	ret
 
 Unknown_41138: ; 41138 (10:5138)
-INCBIN "baserom.gbc",$41138,$4115f - $41138
+INCBIN "baserom.gbc",$41138,$41149 - $41138
+
+Unknown_41149: ; 41149 (10:5149)
+INCBIN "baserom.gbc",$41149,$4115f - $41149
 
 Unknown_4115f: ; 4115f (10:515f)
 INCBIN "baserom.gbc",$4115f,$41181 - $4115f
@@ -69811,7 +70275,7 @@ INCBIN "baserom.gbc",$41217,$4123b - $41217
 .asm_412e7
 	push bc
 	xor a
-	ld de, Unknown_4132e ; $532e
+	ld de, UnknownOAM_4132e ; $532e
 	call WriteOAMBlock
 	ld a, [$d09f]
 	xor $1
@@ -69847,8 +70311,11 @@ INCBIN "baserom.gbc",$41217,$4123b - $41217
 	ld [H_AUTOBGTRANSFERENABLED], a ; $FF00+$ba
 	ret
 
-Unknown_4132e: ; 4132e (10:532e)
-INCBIN "baserom.gbc",$4132e,$41336 - $4132e
+UnknownOAM_4132e: ; 4132e (10:532e)
+	db $7E,$00,$7E,$20
+	db $7E,$40,$7E,$60
+
+Func_41336: ; 41336 (10:5336)
 	ld a, $ac
 	call Func_41676
 	call Func_415c8
@@ -70144,7 +70611,7 @@ Func_41525: ; 41525 (10:5525)
 	ret
 
 Func_41558: ; 41558 (10:5558)
-	ld hl, Unknown_41574 ; $5574
+	ld hl, OAMPointers_41574 ; $5574
 	ld c, $4
 	xor a
 .asm_4155e
@@ -70168,8 +70635,31 @@ Func_41558: ; 41558 (10:5558)
 	jr nz, .asm_4155e
 	ret
 
-Unknown_41574: ; 41574 (10:5574)
-INCBIN "baserom.gbc",$41574,$415a4 - $41574
+OAMPointers_41574: ; 41574 (10:5574)
+	dw UnknownOAM_41584
+	db $08,$08
+	dw UnknownOAM_4158c
+	db $18,$08
+	dw UnknownOAM_41594
+	db $08,$18
+	dw UnknownOAM_4159c
+	db $18,$18
+
+UnknownOAM_41584: ; 41584 (10:5584)
+	db $38,$10,$39,$10
+	db $3A,$10,$3B,$10
+
+UnknownOAM_4158c: ; 4158c (10:558c)
+	db $39,$30,$38,$30
+	db $3B,$30,$3A,$30
+
+UnknownOAM_41594: ; 41594 (10:5594)
+	db $3A,$50,$3B,$50
+	db $38,$50,$39,$50
+
+UnknownOAM_4159c: ; 4159c (10:559c)
+	db $3B,$70,$3A,$70
+	db $39,$70,$38,$70
 
 Func_415a4: ; 415a4 (10:55a4)
 	ld [$cf91], a
@@ -70742,7 +71232,7 @@ SECTION "bank11",ROMX,BANK[$11]
 LavenderTown_h: ; 0x44000 to 0x4402d (45 bytes) (bank=11) (id=4)
 	db $00 ; tileset
 	db LAVENDER_TOWN_HEIGHT, LAVENDER_TOWN_WIDTH ; dimensions (y, x)
-	dw LavenderTownBlocks, LavenderTownTexts, LavenderTownScript ; blocks, texts, scripts
+	dw LavenderTownBlocks, LavenderTownTextPointers, LavenderTownScript ; blocks, texts, scripts
 	db NORTH | SOUTH | WEST ; connections
 
 	; connections data
@@ -70816,8 +71306,16 @@ SafariZoneRestHouse1Blocks: ; 440fb (11:40fb)
 LavenderTownScript: ; 4410b (11:410b)
 	jp EnableAutoTextBoxDrawing
 
-LavenderTownTexts: ; 4410e (11:410e)
-	dw LavenderTownText1, LavenderTownText2, LavenderTownText3, LavenderTownText4, LavenderTownText5, MartSignText, PokeCenterSignText, LavenderTownText8, LavenderTownText9
+LavenderTownTextPointers: ; 4410e (11:410e)
+	dw LavenderTownText1
+	dw LavenderTownText2
+	dw LavenderTownText3
+	dw LavenderTownText4
+	dw LavenderTownText5
+	dw MartSignText
+	dw PokeCenterSignText
+	dw LavenderTownText8
+	dw LavenderTownText9
 
 LavenderTownText1: ; 44120 (11:4120)
 	db $08 ; asm
@@ -71032,7 +71530,7 @@ UnnamedText_4424c: ; 4424c (11:424c)
 ViridianPokecenter_h: ; 0x44251 to 0x4425d (12 bytes) (bank=11) (id=41)
 	db $06 ; tileset
 	db $04, $07 ; dimensions (y, x)
-	dw ViridianPokecenterBlocks, ViridianPokecenterTexts, ViridianPokeCenterScript ; blocks, texts, scripts
+	dw ViridianPokecenterBlocks, ViridianPokecenterTextPointers, ViridianPokeCenterScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw ViridianPokecenterObject ; objects
@@ -71041,8 +71539,11 @@ ViridianPokeCenterScript: ; 4425d (11:425d)
 	call Func_22fa
 	jp EnableAutoTextBoxDrawing
 
-ViridianPokecenterTexts: ; 44263 (11:4263)
-	dw ViridianPokeCenterText1, ViridianPokeCenterText2, ViridianPokeCenterText3, ViridianPokeCenterText4
+ViridianPokecenterTextPointers: ; 44263 (11:4263)
+	dw ViridianPokeCenterText1
+	dw ViridianPokeCenterText2
+	dw ViridianPokeCenterText3
+	dw ViridianPokeCenterText4
 
 ViridianPokeCenterText1: ; 4426b (11:426b)
 	db $ff
@@ -71080,7 +71581,7 @@ ViridianPokecenterObject: ; 0x44277 (size=44)
 Mansion1_h: ; 0x442a3 to 0x442af (12 bytes) (bank=11) (id=165)
 	db $16 ; tileset
 	db MANSION_1_HEIGHT, MANSION_1_WIDTH ; dimensions (y, x)
-	dw Mansion1Blocks, Mansion1Texts, Mansion1Script ; blocks, texts, scripts
+	dw Mansion1Blocks, Mansion1TextPointers, Mansion1Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Mansion1Object ; objects
@@ -71089,7 +71590,7 @@ Mansion1Script: ; 442af (11:42af)
 	call Mansion1Subscript1
 	call EnableAutoTextBoxDrawing
 	ld hl, Mansion1TrainerHeaders
-	ld de, Unknown_44326 ; $4326
+	ld de, Mansion1ScriptPointers
 	ld a, [W_MANSION1CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_MANSION1CURSCRIPT], a
@@ -71134,13 +71635,26 @@ asm_44310: ; 44310 (11:4310)
 	call Predef ; indirect jump to Func_ee9e (ee9e (3:6e9e))
 	ret
 
-INCBIN "baserom.gbc",$44316,$44326 - $44316
+Func_44316: ; 44316 (11:4316)
+	ld a, [$c109]
+	cp $4
+	ret nz
+	xor a
+	ld [H_CURRENTPRESSEDBUTTONS], a
+	ld a, $4
+	ld [H_SPRITEHEIGHT], a
+	jp DisplayTextID
 
-Unknown_44326: ; 44326 (11:4326)
-INCBIN "baserom.gbc",$44326,$4432c - $44326
+Mansion1ScriptPointers: ; 44326 (11:4326)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Mansion1Texts: ; 4432c (11:432c)
-	dw Mansion1Text1, Predef5CText, Predef5CText, Mansion1Text4
+Mansion1TextPointers: ; 4432c (11:432c)
+	dw Mansion1Text1
+	dw Predef5CText
+	dw Predef5CText
+	dw Mansion1Text4
 
 Mansion1TrainerHeaders: ; 44334 (11:4334)
 Mansion1TrainerHeader0: ; 44334 (11:4334)
@@ -71152,7 +71666,7 @@ Mansion1TrainerHeader0: ; 44334 (11:4334)
 	dw Mansion1EndBattleText2 ; 0x4350 TextEndBattle
 	dw Mansion1EndBattleText2 ; 0x4350 TextEndBattle
 
-db $ff
+	db $ff
 
 Mansion1Text1: ; 44341 (11:4341)
 	db $08 ; asm
@@ -71248,166 +71762,220 @@ Mansion1Blocks: ; 443fe (11:43fe)
 RockTunnel1_h: ; 0x444d0 to 0x444dc (12 bytes) (bank=11) (id=82)
 	db $11 ; tileset
 	db ROCK_TUNNEL_1_HEIGHT, ROCK_TUNNEL_1_WIDTH ; dimensions (y, x)
-	dw RockTunnel1Blocks, RockTunnel1Texts, RockTunnel1Script ; blocks, texts, scripts
+	dw RockTunnel1Blocks, RockTunnel1TextPointers, RockTunnel1Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw RockTunnel1Object ; objects
 
 RockTunnel1Script: ; 444dc (11:44dc)
 	call EnableAutoTextBoxDrawing
-	ld hl, Unnamed_44505 ; $4505
-	ld de, Unnamed_444ef ; $44ef
+	ld hl, RockTunnel1TrainerHeaders
+	ld de, RockTunnel1ScriptPointers
 	ld a, [W_ROCKTUNNEL1CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROCKTUNNEL1CURSCRIPT], a
 	ret
 
-Unnamed_444ef: ; 444ef (11:44ef)
-INCBIN "baserom.gbc",$444ef,$444f5 - $444ef
+RockTunnel1ScriptPointers: ; 444ef (11:44ef)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-RockTunnel1Texts: ; 444f5 (11:44f5)
-	dw RockTunnel1Text1, RockTunnel1Text2, RockTunnel1Text3, RockTunnel1Text4, RockTunnel1Text5, RockTunnel1Text6, RockTunnel1Text7, RockTunnel1Text8
+RockTunnel1TextPointers: ; 444f5 (11:44f5)
+	dw RockTunnel1Text1
+	dw RockTunnel1Text2
+	dw RockTunnel1Text3
+	dw RockTunnel1Text4
+	dw RockTunnel1Text5
+	dw RockTunnel1Text6
+	dw RockTunnel1Text7
+	dw RockTunnel1Text8
 
-Unnamed_44505: ; 44505 (11:4505)
-INCBIN "baserom.gbc",$44505,$44511 - $44505
+RockTunnel1TrainerHeaders: ; 44505 (11:4505)
+RockTunnel1TrainerHeader1: ; 44505 (11:4505)
+	db $1 ; flag's bit
+	db ($4 << 4) ; trainer's view range
+	dw $d7d2 ; flag's byte
+	dw RockTunnel1BattleText1 ; 0x4588 TextBeforeBattle
+	dw RockTunnel1AfterBattleText1 ; 0x4592 TextAfterBattle
+	dw RockTunnel1EndBattleText1 ; 0x458d TextEndBattle
+	dw RockTunnel1EndBattleText1 ; 0x458d TextEndBattle
 
-Unknown_44511: ; 44511 (11:4511)
-INCBIN "baserom.gbc",$44511,$4451d - $44511
+RockTunnel1TrainerHeader2: ; 44511 (11:4511)
+	db $2 ; flag's bit
+	db ($4 << 4) ; trainer's view range
+	dw $d7d2 ; flag's byte
+	dw RockTunnel1BattleText2 ; 0x4597 TextBeforeBattle
+	dw RockTunnel1AfterBattleText2 ; 0x45a1 TextAfterBattle
+	dw RockTunnel1EndBattleText2 ; 0x459c TextEndBattle
+	dw RockTunnel1EndBattleText2 ; 0x459c TextEndBattle
 
-Unknown_4451d: ; 4451d (11:451d)
-INCBIN "baserom.gbc",$4451d,$44529 - $4451d
+RockTunnel1TrainerHeader3: ; 4451d (11:451d)
+	db $3 ; flag's bit
+	db ($3 << 4) ; trainer's view range
+	dw $d7d2 ; flag's byte
+	dw RockTunnel1BattleText3 ; 0x45a6 TextBeforeBattle
+	dw RockTunnel1AfterBattleText3 ; 0x45b0 TextAfterBattle
+	dw RockTunnel1EndBattleText3 ; 0x45ab TextEndBattle
+	dw RockTunnel1EndBattleText3 ; 0x45ab TextEndBattle
 
-Unknown_44529: ; 44529 (11:4529)
-INCBIN "baserom.gbc",$44529,$44535 - $44529
+RockTunnel1TrainerHeader4: ; 44529 (11:4529)
+	db $4 ; flag's bit
+	db ($3 << 4) ; trainer's view range
+	dw $d7d2 ; flag's byte
+	dw RockTunnel1BattleText4 ; 0x45b5 TextBeforeBattle
+	dw RockTunnel1AfterBattleText4 ; 0x45bf TextAfterBattle
+	dw RockTunnel1EndBattleText4 ; 0x45ba TextEndBattle
+	dw RockTunnel1EndBattleText4; 0x45ba TextEndBattle
 
-Unknown_44535: ; 44535 (11:4535)
-INCBIN "baserom.gbc",$44535,$44541 - $44535
+RockTunnel1TrainerHeader5: ; 44535 (11:4535)
+	db $5 ; flag's bit
+	db ($4 << 4) ; trainer's view range
+	dw $d7d2 ; flag's byte
+	dw RockTunnel1BattleText5 ; 0x45c4 TextBeforeBattle
+	dw RockTunnel1AfterBattleText5 ; 0x45ce TextAfterBattle
+	dw RockTunnel1EndBattleText5 ; 0x45c9 TextEndBattle
+	dw RockTunnel1EndBattleText5 ; 0x45c9 TextEndBattle
 
-Unknown_44541: ; 44541 (11:4541)
-INCBIN "baserom.gbc",$44541,$4454d - $44541
+RockTunnel1TrainerHeader6: ; 44541 (11:4541)
+	db $6 ; flag's bit
+	db ($4 << 4) ; trainer's view range
+	dw $d7d2 ; flag's byte
+	dw RockTunnel1BattleText6 ; 0x45d3 TextBeforeBattle
+	dw RockTunnel1AfterBattleText6 ; 0x45dd TextAfterBattle
+	dw RockTunnel1EndBattleText6 ; 0x45d8 TextEndBattle
+	dw RockTunnel1EndBattleText6 ; 0x45d8 TextEndBattle
 
-Unknown_4454d: ; 4454d (11:454d)
-INCBIN "baserom.gbc",$4454d,$4455a - $4454d
+RockTunnel1TrainerHeader7: ; 4454d (11:454d)
+	db $7 ; flag's bit
+	db ($4 << 4) ; trainer's view range
+	dw $d7d2 ; flag's byte
+	dw RockTunnel1BattleText7; 0x45e2 TextBeforeBattle
+	dw RockTunnel1AfterBattleText7 ; 0x45ec TextAfterBattle
+	dw RockTunnel1EndBattleText7 ; 0x45e7 TextEndBattle
+	dw RockTunnel1EndBattleText7 ; 0x45e7 TextEndBattle
+
+	db $ff
 
 RockTunnel1Text1: ; 4455a (11:455a)
 	db $8
-	ld hl, Unnamed_44505 ; $4505
+	ld hl, RockTunnel1TrainerHeader1 ; $4505
 	jr asm_0c916 ; 0x4455e $22
 
 RockTunnel1Text2: ; 44560 (11:4560)
 	db $8
-	ld hl, Unknown_44511 ; $4511
+	ld hl, RockTunnel1TrainerHeader2 ; $4511
 	jr asm_0c916 ; 0x44564 $1c
 
 RockTunnel1Text3: ; 44566 (11:4566)
 	db $8
-	ld hl, Unknown_4451d ; $451d
+	ld hl, RockTunnel1TrainerHeader3 ; $451d
 	jr asm_0c916 ; 0x4456a $16
 
 RockTunnel1Text4: ; 4456c (11:456c)
 	db $8
-	ld hl, Unknown_44529 ; $4529
+	ld hl, RockTunnel1TrainerHeader4 ; $4529
 	jr asm_0c916 ; 0x44570 $10
 
 RockTunnel1Text5: ; 44572 (11:4572)
 	db $8
-	ld hl, Unknown_44535 ; $4535
+	ld hl, RockTunnel1TrainerHeader5 ; $4535
 	jr asm_0c916 ; 0x44576 $a
 
 RockTunnel1Text6: ; 44578 (11:4578)
 	db $8
-	ld hl, Unknown_44541 ; $4541
+	ld hl, RockTunnel1TrainerHeader6 ; $4541
 	jr asm_0c916 ; 0x4457c $4
 
 RockTunnel1Text7: ; 4457e (11:457e)
 	db $8
-	ld hl, Unknown_4454d ; $454d
+	ld hl, RockTunnel1TrainerHeader7 ; $454d
 asm_0c916: ; 44582 (11:4582)
 	call TalkToTrainer
 	jp TextScriptEnd
 
-UnnamedText_44588: ; 44588 (11:4588)
-	TX_FAR _UnnamedText_44588
+RockTunnel1BattleText1: ; 44588 (11:4588)
+	TX_FAR _RockTunnel1BattleText1
 	db "@"
 
-UnnamedText_4458d: ; 4458d (11:458d)
-	TX_FAR _UnnamedText_4458d
+RockTunnel1EndBattleText1: ; 4458d (11:458d)
+	TX_FAR _RockTunnel1EndBattleText1
 	db "@"
 
-UnnamedText_44592: ; 44592 (11:4592)
-	TX_FAR _UnnamedText_44592
+RockTunnel1AfterBattleText1: ; 44592 (11:4592)
+	TX_FAR _RockTunnel1AfterBattleText1
 	db "@"
 
-UnnamedText_44597: ; 44597 (11:4597)
-	TX_FAR _UnnamedText_44597
+RockTunnel1BattleText2: ; 44597 (11:4597)
+	TX_FAR _RockTunnel1BattleText2
 	db "@"
 
-UnnamedText_4459c: ; 4459c (11:459c)
-	TX_FAR _UnnamedText_4459c
+RockTunnel1EndBattleText2: ; 4459c (11:459c)
+	TX_FAR _RockTunnel1EndBattleText2
 	db "@"
 
-UnnamedText_445a1: ; 445a1 (11:45a1)
-	TX_FAR _UnnamedText_445a1
+RockTunnel1AfterBattleText2: ; 445a1 (11:45a1)
+	TX_FAR _RockTunnel1AfterBattleText2
 	db "@"
 
-UnnamedText_445a6: ; 445a6 (11:45a6)
-	TX_FAR _UnnamedText_445a6
+RockTunnel1BattleText3: ; 445a6 (11:45a6)
+	TX_FAR _RockTunnel1BattleText3
 	db "@"
 
-UnnamedText_445ab: ; 445ab (11:45ab)
-	TX_FAR _UnnamedText_445ab
+RockTunnel1EndBattleText3: ; 445ab (11:45ab)
+	TX_FAR _RockTunnel1EndBattleText3
 	db "@"
 
-UnnamedText_445b0: ; 445b0 (11:45b0)
-	TX_FAR _UnnamedText_445b0
+RockTunnel1AfterBattleText3: ; 445b0 (11:45b0)
+	TX_FAR _RockTunnel1AfterBattleText3
 	db "@"
 
-UnnamedText_445b5: ; 445b5 (11:45b5)
-	TX_FAR _UnnamedText_445b5
+RockTunnel1BattleText4: ; 445b5 (11:45b5)
+	TX_FAR _RockTunnel1BattleText4
 	db "@"
 
-UnnamedText_445ba: ; 445ba (11:45ba)
-	TX_FAR _UnnamedText_445ba
+RockTunnel1EndBattleText4: ; 445ba (11:45ba)
+	TX_FAR _RockTunnel1EndBattleText4
 	db "@"
 
-UnnamedText_445bf: ; 445bf (11:45bf)
-	TX_FAR _UnnamedText_445bf
+RockTunnel1AfterBattleText4: ; 445bf (11:45bf)
+	TX_FAR _RockTunnel1AfterBattleText4
 	db "@"
 
-UnnamedText_445c4: ; 445c4 (11:45c4)
-	TX_FAR _UnnamedText_445c4
+RockTunnel1BattleText5: ; 445c4 (11:45c4)
+	TX_FAR _RockTunnel1BattleText5
 	db "@"
 
-UnnamedText_445c9: ; 445c9 (11:45c9)
-	TX_FAR _UnnamedText_445c9
+RockTunnel1EndBattleText5: ; 445c9 (11:45c9)
+	TX_FAR _RockTunnel1EndBattleText5
 	db "@"
 
-UnnamedText_445ce: ; 445ce (11:45ce)
-	TX_FAR _UnnamedText_445ce
+RockTunnel1AfterBattleText5: ; 445ce (11:45ce)
+	TX_FAR _RockTunnel1AfterBattleText5
 	db "@"
 
-UnnamedText_445d3: ; 445d3 (11:45d3)
-	TX_FAR _UnnamedText_445d3
+RockTunnel1BattleText6: ; 445d3 (11:45d3)
+	TX_FAR _RockTunnel1BattleText6
 	db "@"
 
-UnnamedText_445d8: ; 445d8 (11:45d8)
-	TX_FAR _UnnamedText_445d8
+RockTunnel1EndBattleText6: ; 445d8 (11:45d8)
+	TX_FAR _RockTunnel1EndBattleText6
 	db "@"
 
-UnnamedText_445dd: ; 445dd (11:45dd)
-	TX_FAR _UnnamedText_445dd
+RockTunnel1AfterBattleText6: ; 445dd (11:45dd)
+	TX_FAR _RockTunnel1AfterBattleText6
 	db "@"
 
-UnnamedText_445e2: ; 445e2 (11:45e2)
-	TX_FAR _UnnamedText_445e2
+RockTunnel1BattleText7: ; 445e2 (11:45e2)
+	TX_FAR _RockTunnel1BattleText7
 	db "@"
 
-UnnamedText_445e7: ; 445e7 (11:45e7)
-	TX_FAR _UnnamedText_445e7
+RockTunnel1EndBattleText7: ; 445e7 (11:45e7)
+	TX_FAR _RockTunnel1EndBattleText7
 	db "@"
 
-UnnamedText_445ec: ; 445ec (11:45ec)
-	TX_FAR _UnnamedText_445ec
+RockTunnel1AfterBattleText7: ; 445ec (11:45ec)
+	TX_FAR _RockTunnel1AfterBattleText7
 	db "@"
 
 RockTunnel1Text8: ; 445f1 (11:45f1)
@@ -71455,7 +72023,7 @@ RockTunnel1Blocks: ; 44675 (11:4675)
 SeafoamIslands1_h: ; 0x447dd to 0x447e9 (12 bytes) (bank=11) (id=192)
 	db $11 ; tileset
 	db SEAFOAM_ISLANDS_1_HEIGHT, SEAFOAM_ISLANDS_1_WIDTH ; dimensions (y, x)
-	dw SeafoamIslands1Blocks, SeafoamIslands1Texts, SeafoamIslands1Script ; blocks, texts, scripts
+	dw SeafoamIslands1Blocks, SeafoamIslands1TextPointers, SeafoamIslands1Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw SeafoamIslands1Object ; objects
@@ -71507,8 +72075,9 @@ Seafoam1HolesCoords: ; 44846 (11:4846)
 	db $06,$18
 	db $ff
 
-SeafoamIslands1Texts: ; 4484b (11:484b)
-	dw BoulderText, BoulderText
+SeafoamIslands1TextPointers: ; 4484b (11:484b)
+	dw BoulderText
+	dw BoulderText
 
 SeafoamIslands1Object: ; 0x4484f (size=72)
 	db $7d ; border tile
@@ -71545,7 +72114,7 @@ SeafoamIslands1Blocks: ; 4489f (11:489f)
 SSAnne3_h: ; 0x44926 to 0x44932 (12 bytes) (bank=11) (id=97)
 	db $0d ; tileset
 	db SS_ANNE_3_HEIGHT, SS_ANNE_3_WIDTH ; dimensions (y, x)
-	dw SSAnne3Blocks, SSAnne3Texts, SSAnne3Script ; blocks, texts, scripts
+	dw SSAnne3Blocks, SSAnne3TextPointers, SSAnne3Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw SSAnne3Object ; objects
@@ -71553,7 +72122,7 @@ SSAnne3_h: ; 0x44926 to 0x44932 (12 bytes) (bank=11) (id=97)
 SSAnne3Script: ; 44932 (11:4932)
 	jp EnableAutoTextBoxDrawing
 
-SSAnne3Texts: ; 44935 (11:4935)
+SSAnne3TextPointers: ; 44935 (11:4935)
 	dw SSAnne3Text1
 
 SSAnne3Text1: ; 44937 (11:4937)
@@ -71582,7 +72151,7 @@ SSAnne3Blocks: ; 44956 (11:4956)
 VictoryRoad3_h: ; 0x44974 to 0x44980 (12 bytes) (bank=11) (id=198)
 	db $11 ; tileset
 	db VICTORY_ROAD_3_HEIGHT, VICTORY_ROAD_3_WIDTH ; dimensions (y, x)
-	dw VictoryRoad3Blocks, VictoryRoad3Texts, VictoryRoad3Script ; blocks, texts, scripts
+	dw VictoryRoad3Blocks, VictoryRoad3TextPointers, VictoryRoad3Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw VictoryRoad3Object ; objects
@@ -71591,7 +72160,7 @@ VictoryRoad3Script: ; 44980 (11:4980)
 	call VictoryRoad3Script_Unknown44996
 	call EnableAutoTextBoxDrawing
 	ld hl, VictoryRoad3TrainerHeaders
-	ld de, Unknown_449b1 ; $49b1
+	ld de, VictoryRoad3ScriptPointers
 	ld a, [W_VICTORYROAD3CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_VICTORYROAD3CURSCRIPT], a
@@ -71611,13 +72180,17 @@ VictoryRoad3Script_Unknown44996: ; 44996 (11:4996)
 	ld a, $17
 	jp Predef ; indirect jump to Func_ee9e (ee9e (3:6e9e))
 
-Unknown_449b1: ; 449b1 (11:49b1)
-INCBIN "baserom.gbc",$449b1,$449b7 - $449b1
+VictoryRoad3ScriptPointers: ; 449b1 (11:49b1)
+	dw VictoryRoad3Script0
+	dw Func_324c
+	dw EndTrainerBattle
+
+VictoryRoad3Script0: ; 449b7 (11:49b7)
 	ld hl, wFlags_0xcd60
 	bit 7, [hl]
 	res 7, [hl]
 	jp z, .asm_449fe
-	ld hl, .unknown_449f9 ; $49f9
+	ld hl, .coordsData_449f9 ; $49f9
 	call CheckBoulderCoords
 	jp nc, .asm_449fe
 	ld a, [wWhichTrade] ; $cd3d
@@ -71642,13 +72215,15 @@ INCBIN "baserom.gbc",$449b1,$449b7 - $449b1
 	ld a, $15
 	jp Predef ; indirect jump to AddMissableObject (f1c8 (3:71c8))
 
-.unknown_449f9: ; 449f9 (11:49f9)
-INCBIN "baserom.gbc",$449f9,$449fe - $449f9
+.coordsData_449f9: ; 449f9 (11:49f9)
+	db $05,$03
+	db $0F,$17
+	db $FF
 
 .asm_449fe
 	ld a, $c2
 	ld [$d71d], a
-	ld hl, .unknown_449f9 ; $49f9
+	ld hl, .coordsData_449f9 ; $49f9
 	call Func_46981
 	ld a, [wWhichTrade] ; $cd3d
 	cp $1
@@ -71664,8 +72239,17 @@ INCBIN "baserom.gbc",$449f9,$449fe - $449f9
 	jp z, CheckFightingMapTrainers
 	ret
 
-VictoryRoad3Texts: ; 44a24 (11:4a24)
-	dw VictoryRoad3Text1, VictoryRoad3Text2, VictoryRoad3Text3, VictoryRoad3Text4, Predef5CText, Predef5CText, BoulderText, BoulderText, BoulderText, BoulderText
+VictoryRoad3TextPointers: ; 44a24 (11:4a24)
+	dw VictoryRoad3Text1
+	dw VictoryRoad3Text2
+	dw VictoryRoad3Text3
+	dw VictoryRoad3Text4
+	dw Predef5CText
+	dw Predef5CText
+	dw BoulderText
+	dw BoulderText
+	dw BoulderText
+	dw BoulderText
 
 VictoryRoad3TrainerHeaders: ; 44a38 (11:4a38)
 VictoryRoad3TrainerHeader0: ; 44a38 (11:4a38)
@@ -71704,7 +72288,7 @@ VictoryRoad3TrainerHeader4: ; 44a5c (11:4a5c)
 	dw VictoryRoad3EndBattleText5 ; 0x4ac3 TextEndBattle
 	dw VictoryRoad3EndBattleText5 ; 0x4ac3 TextEndBattle
 
-db $ff
+	db $ff
 
 VictoryRoad3Text1: ; 44a69 (11:4a69)
 	db $08 ; asm
@@ -71813,29 +72397,59 @@ VictoryRoad3Blocks: ; 44b37 (11:4b37)
 RocketHideout1_h: ; 0x44bbe to 0x44bca (12 bytes) (bank=11) (id=199)
 	db $16 ; tileset
 	db ROCKET_HIDEOUT_1_HEIGHT, ROCKET_HIDEOUT_1_WIDTH ; dimensions (y, x)
-	dw RocketHideout1Blocks, RocketHideout1Texts, RocketHideout1Script ; blocks, texts, scripts
+	dw RocketHideout1Blocks, RocketHideout1TextPointers, RocketHideout1Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw RocketHideout1Object ; objects
 
 RocketHideout1Script: ; 44bca (11:4bca)
-	call Unknown_44be0
+	call Func_44be0
 	call EnableAutoTextBoxDrawing
 	ld hl, RocketHideout1TrainerHeaders
-	ld de, Unknown_44c0e ; $4c0e
+	ld de, RocketHideout1ScriptPointers
 	ld a, [W_ROCKETHIDEOUT1CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROCKETHIDEOUT1CURSCRIPT], a
 	ret
 
-Unknown_44be0: ; 44be0 (11:4be0)
-INCBIN "baserom.gbc",$44be0,$44c0e - $44be0
+Func_44be0: ; 44be0 (11:4be0)
+	ld hl, $d126
+	bit 5, [hl]
+	res 5, [hl]
+	ret z
+	ld a, [$d815]
+	bit 7, a
+	jr nz, .asm_44c01
+	bit 5, a
+	jr nz, .asm_44bf7
+	ld a, $54
+	jr .asm_44c03
+.asm_44bf7
+	ld a, $ad
+	call $23b1
+	ld hl, $d815
+	bit 7, [hl]
+.asm_44c01
+	ld a, $e
+.asm_44c03
+	ld [$d09f], a
+	ld bc, $080c
+	ld a, $17
+	jp Predef
 
-Unknown_44c0e: ; 44c0e (11:4c0e)
-INCBIN "baserom.gbc",$44c0e,$44c14 - $44c0e
+RocketHideout1ScriptPointers: ; 44c0e (11:4c0e)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-RocketHideout1Texts: ; 44c14 (11:4c14)
-	dw RocketHideout1Text1, RocketHideout1Text2, RocketHideout1Text3, RocketHideout1Text4, RocketHideout1Text5, Predef5CText, Predef5CText
+RocketHideout1TextPointers: ; 44c14 (11:4c14)
+	dw RocketHideout1Text1
+	dw RocketHideout1Text2
+	dw RocketHideout1Text3
+	dw RocketHideout1Text4
+	dw RocketHideout1Text5
+	dw Predef5CText
+	dw Predef5CText
 
 RocketHideout1TrainerHeaders: ; 44c22 (11:4c22)
 RocketHideout1TrainerHeader0: ; 44c22 (11:4c22)
@@ -71883,7 +72497,7 @@ RocketHideout1TrainerHeader5: ; 44c52 (11:4c52)
 	dw RocketHideout1EndBattleText6 ; 0x4c91 TextEndBattle
 	dw RocketHideout1EndBattleText6 ; 0x4c91 TextEndBattle
 
-db $ff
+	db $ff
 
 RocketHideout1Text1: ; 44c5f (11:4c5f)
 	db $08 ; asm
@@ -72016,7 +72630,7 @@ RocketHideout1Blocks: ; 44d49 (11:4d49)
 RocketHideout2_h: ; 0x44e1b to 0x44e27 (12 bytes) (bank=11) (id=200)
 	db $16 ; tileset
 	db ROCKET_HIDEOUT_2_HEIGHT, ROCKET_HIDEOUT_2_WIDTH ; dimensions (y, x)
-	dw RocketHideout2Blocks, RocketHideout2Texts, RocketHideout2Script ; blocks, texts, scripts
+	dw RocketHideout2Blocks, RocketHideout2TextPointers, RocketHideout2Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw RocketHideout2Object ; objects
@@ -72024,14 +72638,321 @@ RocketHideout2_h: ; 0x44e1b to 0x44e27 (12 bytes) (bank=11) (id=200)
 RocketHideout2Script: ; 44e27 (11:4e27)
 	call EnableAutoTextBoxDrawing
 	ld hl, RocketHideout2TrainerHeaders
-	ld de, RocketHideout2_Unknown44e3a
+	ld de, RocketHideout2ScriptPointers
 	ld a, [W_ROCKETHIDEOUT2CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROCKETHIDEOUT2CURSCRIPT], a
 	ret
 
-RocketHideout2_Unknown44e3a: ; 44e3a (11:4e3a)
-INCBIN "baserom.gbc",$44e3a,$44fd7 - $44e3a
+RocketHideout2ScriptPointers: ; 44e3a (11:4e3a)
+	dw RocketHideout2Script0
+	dw Func_324c
+	dw EndTrainerBattle
+	dw RocketHideout2Script3
+
+RocketHideout2Script0: ; 44e42 (11:4e42)
+	ld a, [W_YCOORD]
+	ld b, a
+	ld a, [W_XCOORD]
+	ld c, a
+	ld hl, RocketHideout2ArrowTilePlayerMovement
+	call Func_3442
+	cp $ff
+	jp z, CheckFightingMapTrainers
+	ld hl, $d736
+	set 7, [hl]
+	call Func_3486
+	ld a, $a7
+	call PlaySound
+	ld a, $ff
+	ld [wJoypadForbiddenButtonsMask], a
+	ld a, $3
+	ld [W_CURMAPSCRIPT], a
+	ret
+
+;format:
+;db y,x
+;dw pointer to movement
+RocketHideout2ArrowTilePlayerMovement: ; 44e6d (11:4e6d)
+	db $9,$4
+	dw RocketHideout2ArrowMovement1
+	db $b,$4
+	dw RocketHideout2ArrowMovement2
+	db $f,$4
+	dw RocketHideout2ArrowMovement3
+	db $10,$4
+	dw RocketHideout2ArrowMovement4
+	db $13,$4
+	dw RocketHideout2ArrowMovement1
+	db $16,$4
+	dw RocketHideout2ArrowMovement5
+	db $e,$5
+	dw RocketHideout2ArrowMovement6
+	db $16,$6
+	dw RocketHideout2ArrowMovement7
+	db $18,$6
+	dw RocketHideout2ArrowMovement8
+	db $9,$8
+	dw RocketHideout2ArrowMovement9
+	db $c,$8
+	dw RocketHideout2ArrowMovement10
+	db $f,$8
+	dw RocketHideout2ArrowMovement8
+	db $13,$8
+	dw RocketHideout2ArrowMovement9
+	db $17,$8
+	dw RocketHideout2ArrowMovement11
+	db $e,$9
+	dw RocketHideout2ArrowMovement12
+	db $16,$9
+	dw RocketHideout2ArrowMovement12
+	db $9,$a
+	dw RocketHideout2ArrowMovement13
+	db $a,$a
+	dw RocketHideout2ArrowMovement14
+	db $f,$a
+	dw RocketHideout2ArrowMovement15
+	db $11,$a
+	dw RocketHideout2ArrowMovement16
+	db $13,$a
+	dw RocketHideout2ArrowMovement17
+	db $19,$a
+	dw RocketHideout2ArrowMovement2
+	db $e,$b
+	dw RocketHideout2ArrowMovement18
+	db $10,$b
+	dw RocketHideout2ArrowMovement19
+	db $12,$b
+	dw RocketHideout2ArrowMovement12
+	db $9,$c
+	dw RocketHideout2ArrowMovement20
+	db $b,$c
+	dw RocketHideout2ArrowMovement21
+	db $d,$c
+	dw RocketHideout2ArrowMovement22
+	db $11,$c
+	dw RocketHideout2ArrowMovement23
+	db $a,$d
+	dw RocketHideout2ArrowMovement24
+	db $c,$d
+	dw RocketHideout2ArrowMovement25
+	db $10,$d
+	dw RocketHideout2ArrowMovement26
+	db $12,$d
+	dw RocketHideout2ArrowMovement27
+	db $13,$d
+	dw RocketHideout2ArrowMovement28
+	db $16,$d
+	dw RocketHideout2ArrowMovement29
+	db $17,$d
+	dw RocketHideout2ArrowMovement30
+	db $11,$e
+	dw RocketHideout2ArrowMovement31
+	db $10,$f
+	dw RocketHideout2ArrowMovement12
+	db $e,$10
+	dw RocketHideout2ArrowMovement32
+	db $10,$10
+	dw RocketHideout2ArrowMovement33
+	db $12,$10
+	dw RocketHideout2ArrowMovement34
+	db $a,$11
+	dw RocketHideout2ArrowMovement35
+	db $b,$11
+	dw RocketHideout2ArrowMovement36
+	db $FF
+
+;format: direction, count
+;right:	$10
+;left:	$20
+;up:	$40
+;down:	$80
+;each list is read starting from the $FF and working backwards
+RocketHideout2ArrowMovement1: ; 44f1a (11:4f1a)
+	db $20,$02
+	db $FF
+
+RocketHideout2ArrowMovement2: ; 44f1d (11:4f1d)
+	db $10,$04
+	db $FF
+
+RocketHideout2ArrowMovement3: ; 44f20 (11:4f20)
+	db $40,$04
+	db $10,$04
+	db $FF
+
+RocketHideout2ArrowMovement4: ; 44f25 (11:4f25)
+	db $40,$04
+	db $10,$04
+	db $40,$01
+	db $FF
+
+RocketHideout2ArrowMovement5: ; 44f2c (11:4f2c)
+	db $20,$02
+	db $40,$03
+	db $FF
+
+RocketHideout2ArrowMovement6: ; 44f31 (11:4f31)
+	db $80,$02
+	db $10,$04
+	db $FF
+
+RocketHideout2ArrowMovement7: ; 44f36 (11:4f36)
+	db $40,$02
+	db $FF
+
+RocketHideout2ArrowMovement8: ; 44f39 (11:4f39)
+	db $40,$04
+	db $FF
+
+RocketHideout2ArrowMovement9: ; 44f3c (11:4f3c)
+	db $20,$06
+	db $FF
+
+RocketHideout2ArrowMovement10: ; 44f3f (11:4f3f)
+	db $40,$01
+	db $FF
+
+RocketHideout2ArrowMovement11: ; 44f42 (11:4f42)
+	db $20,$06
+	db $40,$04
+	db $FF
+
+RocketHideout2ArrowMovement12: ; 44f47 (11:4f47)
+	db $80,$02
+	db $FF
+
+RocketHideout2ArrowMovement13: ; 44f4a (11:4f4a)
+	db $20,$08
+	db $FF
+
+RocketHideout2ArrowMovement14: ; 44f4d (11:4f4d)
+	db $20,$08
+	db $40,$01
+	db $FF
+
+RocketHideout2ArrowMovement15: ; 44f52 (11:4f52)
+	db $20,$08
+	db $40,$06
+	db $FF
+
+RocketHideout2ArrowMovement16: ; 44f57 (11:4f57)
+	db $40,$02
+	db $10,$04
+	db $FF
+
+RocketHideout2ArrowMovement17: ; 44f5c (11:4f5c)
+	db $40,$02
+	db $10,$04
+	db $40,$02
+	db $FF
+
+RocketHideout2ArrowMovement18: ; 44f63 (11:4f63)
+	db $80,$02
+	db $10,$04
+	db $80,$02
+	db $FF
+
+RocketHideout2ArrowMovement19: ; 44f6a (11:4f6a)
+	db $80,$02
+	db $10,$04
+	db $FF
+
+RocketHideout2ArrowMovement20: ; 44f6f (11:4f6f)
+	db $20,$0A
+	db $FF
+
+RocketHideout2ArrowMovement21: ; 44f72 (11:4f72)
+	db $20,$0A
+	db $40,$02
+	db $FF
+
+RocketHideout2ArrowMovement22: ; 44f77 (11:4f77)
+	db $20,$0A
+	db $40,$04
+	db $FF
+
+RocketHideout2ArrowMovement23: ; 44f7c (11:4f7c)
+	db $40,$02
+	db $10,$02
+	db $FF
+
+RocketHideout2ArrowMovement24: ; 44f81 (11:4f81)
+	db $10,$01
+	db $80,$02
+	db $FF
+
+RocketHideout2ArrowMovement25: ; 44f86 (11:4f86)
+	db $10,$01
+	db $FF
+
+RocketHideout2ArrowMovement26: ; 44f89 (11:4f89)
+	db $80,$02
+	db $10,$02
+	db $FF
+
+RocketHideout2ArrowMovement27: ; 44f8e (11:4f8e)
+	db $80,$02
+	db $20,$02
+	db $FF
+
+RocketHideout2ArrowMovement28: ; 44f93 (11:4f93)
+	db $40,$02
+	db $10,$04
+	db $40,$02
+	db $20,$03
+	db $FF
+
+RocketHideout2ArrowMovement29: ; 44f9c (11:4f9c)
+	db $80,$02
+	db $20,$04
+	db $FF
+
+RocketHideout2ArrowMovement30: ; 44fa1 (11:4fa1)
+	db $20,$06
+	db $40,$04
+	db $20,$05
+	db $FF
+
+RocketHideout2ArrowMovement31: ; 44fa8 (11:4fa8)
+	db $40,$02
+	db $FF
+
+RocketHideout2ArrowMovement32: ; 44fab (11:4fab)
+	db $40,$01
+	db $FF
+
+RocketHideout2ArrowMovement33: ; 44fae (11:4fae)
+	db $40,$03
+	db $FF
+
+RocketHideout2ArrowMovement34: ; 44fb1 (11:4fb1)
+	db $40,$05
+	db $FF
+
+RocketHideout2ArrowMovement35: ; 44fb4 (11:4fb4)
+	db $10,$01
+	db $80,$02
+	db $20,$04
+	db $FF
+
+RocketHideout2ArrowMovement36: ; 44fbb (11:4fbb)
+	db $20,$0A
+	db $40,$02
+	db $20,$05
+	db $FF
+
+RocketHideout2Script3: ; 44fc2 (11:4fc2)
+	ld a, [$cd38]
+	and a
+	jr nz, Func_44fd7
+	xor a
+	ld [wJoypadForbiddenButtonsMask], a
+	ld hl, $d736
+	res 7, [hl]
+	ld a, $0
+	ld [W_CURMAPSCRIPT], a
+	ret
 
 Func_44fd7: ; 44fd7 (11:4fd7)
 	ld a, [$c102]
@@ -72174,8 +73095,12 @@ INCBIN "baserom.gbc",$45083,$45087 - $45083
 SpinnerArrowAnimTiles: ; 45087 (11:5087)
 	INCBIN "gfx/spinner_arrow.2bpp"
 
-RocketHideout2Texts: ; 450c7 (11:50c7)
-	dw RocketHideout2Text1, Predef5CText, Predef5CText, Predef5CText, Predef5CText
+RocketHideout2TextPointers: ; 450c7 (11:50c7)
+	dw RocketHideout2Text1
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
 
 RocketHideout2TrainerHeaders: ; 450d1 (11:50d1)
 RocketHideout2TrainerHeader0: ; 450d1 (11:50d1)
@@ -72187,7 +73112,7 @@ RocketHideout2TrainerHeader0: ; 450d1 (11:50d1)
 	dw RocketHideout2EndBattleText2 ; 0x50ed TextEndBattle
 	dw RocketHideout2EndBattleText2 ; 0x50ed TextEndBattle
 
-db $ff
+	db $ff
 
 RocketHideout2Text1: ; 450de (11:50de)
 	db $08 ; asm
@@ -72239,7 +73164,7 @@ RocketHideout2Blocks: ; 45147 (11:5147)
 RocketHideout3_h: ; 0x45219 to 0x45225 (12 bytes) (bank=11) (id=201)
 	db $16 ; tileset
 	db ROCKET_HIDEOUT_3_HEIGHT, ROCKET_HIDEOUT_3_WIDTH ; dimensions (y, x)
-	dw RocketHideout3Blocks, RocketHideout3Texts, RocketHideout3Script ; blocks, texts, scripts
+	dw RocketHideout3Blocks, RocketHideout3TextPointers, RocketHideout3Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw RocketHideout3Object ; objects
